Unit LibMatice;
interface

Type Matica=array[1..10,1..10] of real;
     Vektor=array[1..10] of real;

Var i,j,k: integer;
    s,sum:real;

Procedure Nacitaj(nazov:string; var dim:integer; var D:Matica; var b:Vektor);
Procedure Nasob(dim:integer; AA,BB:Matica; var CC:Matica);
Procedure Vypis(dim:integer; AA:matica);
Procedure LUmetoda(dim:integer; AA:matica; Var L,U:Matica);
Procedure IteraciaDown(dim:integer; AA:Matica; bb:vektor; var xx:Vektor);
Procedure IteraciaUp(dim:integer; AA:Matica; bb:vektor; var xx:Vektor);
Procedure Jacobi(dim:integer; A:Matica; b,x:vektor; var y:vektor);


implementation
uses Unit1;

Procedure Nacitaj(nazov:string; var dim:integer; var D:Matica; var b:Vektor);
var i,j:integer;
    t:text;
begin
  AssignFile(t,nazov); Reset(t);
  readln(t,dim);
  for i:=1 to dim do begin
     for j:=1 to dim do
         read(t,D[i,j]);
      read(t,b[i])
   end;
   CloseFile(t);
end;

Procedure Nasob;
begin
for i:=1 to dim do begin
    for j:=1 to dim do begin
        s:=0;
        for k:=1 to dim do
        s:=s+AA[i,k]*BB[k,j];
        cC[i,j]:=s;
  end;
end;
end;


Procedure Vypis;
Var data,subor:string;
begin
  Form1.Memo1.Lines.Add('Matica');
  Data:=' ';
  for i:=1 to dim do begin
    for j:=1 to dim do begin
      str(AA[i,j]:2:2, Subor);
      Insert(Subor+'  ',Data,Length(Data));
    end;
    Form1.Memo1.Lines.Add(Data);
    Data:=' ';
  end;;
end;

Procedure LUmetoda(dim:integer; AA:matica; Var L,U:Matica);
Var
  i,j,k:integer;
begin
 for i:=1 to dim do begin
   for j:=1 to dim do  begin
     U[i,j]:=0;L[i,j]:=0;
   end;
 end;
 for j:=1 to dim do begin
  for i:=1 to j do
begin
     sum:=0;
     for k:=1 to i-1  do
        sum:= sum+l[i,k]*u[k,j];
     u[i,j]:=AA[i,j]-sum;
 end;
  for i:=j+1 to dim  do
 begin
     sum:=0;
     for k:=1 to j-1 do
        sum:=sum+l[i,k]*U[k,j];
   L[i,j]:=(AA[i,j]-sum)/U[j,j];
    end;
  end;
     for k:=1 to dim do
        L[k,k]:=1;
end;

Procedure IteraciaDown;
begin
  for i:=1 to dim do begin
     s:=0;
     for j:=1 to i-1 do s:=s + AA[i,j]*xx[j];
     xx[i]:=(bb[i]-s)/AA[i,i];
  end;
end;

Procedure IteraciaUp;
begin
  for i:=dim downto 1 do begin
     s:=0;
     for j:=i+1 to dim do s:=s + AA[i,j]*xx[j];
     xx[i]:=(bb[i]-s)/AA[i,i];
  end;
end;

Procedure Jacobi;
Var
  i,j:integer;
begin
  for i:=1 to dim do begin
   y[i]:=0;
    for j:=1 to dim do begin
{      if i=j then j:=j+1; }
      if j=dim+1 then break else;
      Y[i]:=Y[i]+A[i,j]*x[j];
    end;
    Y[i]:=(b[i]-Y[i])/A[i,i];
  end;
end;

Begin
end.

